Index: apps/app_dial.c
===================================================================
--- apps/app_dial.c	(revision 92267)
+++ apps/app_dial.c	(working copy)
@@ -754,25 +754,6 @@
 		}
 		
 	}
-	if (peer && !ast_cdr_log_unanswered()) {
-		/* suppress the CDR's that didn't win */
-		struct dial_localuser *o;
-		for (o = outgoing; o; o = o->next) {
-			struct ast_channel *c = o->chan;
-			if (c && c != peer && c->cdr) {
-				ast_set_flag(c->cdr, AST_CDR_FLAG_POST_DISABLED);
-			}
-		}
-	} else if (!peer && !ast_cdr_log_unanswered()) {
-			/* suppress the CDR's that didn't win */
-		struct dial_localuser *o;
-		for (o = outgoing; o; o = o->next) {
-			struct ast_channel *c = o->chan;
-			if (c && c->cdr) {
-				ast_set_flag(c->cdr, AST_CDR_FLAG_POST_DISABLED);		
-			}
-		}
-	}
 	
 	return peer;
 }
Index: include/asterisk/cdr.h
===================================================================
--- include/asterisk/cdr.h	(revision 92267)
+++ include/asterisk/cdr.h	(working copy)
@@ -100,7 +100,6 @@
 int ast_cdr_serialize_variables(struct ast_cdr *cdr, char *buf, size_t size, char delim, char sep, int recur);
 void ast_cdr_free_vars(struct ast_cdr *cdr, int recur);
 int ast_cdr_copy_vars(struct ast_cdr *to_cdr, struct ast_cdr *from_cdr);
-int ast_cdr_log_unanswered(void);
 
 typedef int (*ast_cdrbe)(struct ast_cdr *cdr);
 
Index: main/cdr.c
===================================================================
--- main/cdr.c	(revision 92267)
+++ main/cdr.c	(working copy)
@@ -103,11 +103,6 @@
 static ast_cond_t cdr_pending_cond;
 
 
-int ast_cdr_log_unanswered(void)
-{
-	return unanswered;
-}
-
 /*! Register a CDR driver. Each registered CDR driver generates a CDR 
 	\return 0 on success, -1 on failure 
 */
@@ -990,6 +985,12 @@
 	struct ast_cdr_beitem *i;
 
 	for ( ; cdr ; cdr = cdr->next) {
+		if (!unanswered && cdr->disposition < AST_CDR_ANSWERED && (ast_strlen_zero(cdr->channel) || ast_strlen_zero(cdr->dstchannel))) {
+			/* For people, who don't want to see unanswered single-channel events */
+			ast_set_flag(cdr, AST_CDR_FLAG_POST_DISABLED);
+			continue;
+		}
+
 		chan = S_OR(cdr->channel, "<unknown>");
 		check_post(cdr);
 		if (ast_tvzero(cdr->end))
